using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using Exferia_Maestros.General;
using Exferia_General;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;

namespace Exferia_Maestros._3_Vistas.Listados
{
    public class ABS_Listado_MAE_Articulos_Temporadas : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MAE_Articulos_Temporadas()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, false, false, "", null));

            //Ordenacion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.Ordenacion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.Ordenacion), "Ordenacion", Enumerados.G_ENUM_TIPOSDATOS.TEXT, true, 0, false, false, false, false, "", null));

            //Desde
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.Desde), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.Desde), "Desde", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, true, true, false, "", null,false));
            
            //Hasta
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.Hasta), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.Hasta), "Hasta", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, true, true, false, "", null, false));

            //cantidad_Minima
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.cantidad_Minima), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.cantidad_Minima), "Cantidad mínima", Enumerados.G_ENUM_TIPOSDATOS.DECIMAL, false, 150, true, false, true, false, "", null, true));

            //cantidad_Maxima
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.cantidad_Maxima), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.cantidad_Maxima), "Cantidad máxima", Enumerados.G_ENUM_TIPOSDATOS.DECIMAL, false, 150, true, false, true, false, "", null, true));

            //puntoPedido
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.puntoPedido), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.puntoPedido), "Punto pedido", Enumerados.G_ENUM_TIPOSDATOS.DECIMAL, false, 150, true, false, true, false, "", null,true));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MAE_ARTICULO_TEMPORADA);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_MAE_ARTICULO_TEMPORADA;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_MAE_Articulos_Temporadas_Listado_Modelo.Desde);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "1";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
